%{
//      GPPGParser,   ,   gppg
    public Parser(AbstractScanner<int, LexLocation> scanner) : base(scanner) { }
%}

%output = SimpleYacc.cs

%namespace SimpleParser

%token BEGIN END CYCLE INUM RNUM ID ASSIGN SEMICOLON WHILE DO REPEAT UNTIL FOR TO IF THEN ELSE LEFT_BRACKET WRITE RIGHT_BRACKET VAR COMMA PLUS MINUS MULT DIVISION

%%

progr   : block
		;

stlist	: statement 
		| stlist SEMICOLON statement 
		;

statement: assign
		| block  
		| cycle  
		| while
		| repeat
		| for
		| if
		| write
		| var
		;

ident 	: ID 
		;

idlist	: ident
		| idlist COMMA ident
		;
	
assign 	: ident ASSIGN expr 
		;

expr : T
     | expr PLUS T
     | expr MINUS T
     ;

block	: BEGIN stlist END 
		;

cycle	: CYCLE expr statement 
		;

while	: WHILE expr DO statement 
		;

repeat	: REPEAT stlist UNTIL expr
		;

for		: FOR assign TO expr DO statement
		;
if		: IF expr THEN statement ELSE statement
		| IF expr THEN statement
		;
write	: WRITE LEFT_BRACKET expr RIGHT_BRACKET
		;

var		: VAR idlist
		;

T    : F
     | T MULT F
     | T DIVISION F
     ;

F    : ident
     | INUM 
     | LEFT_BRACKET expr RIGHT_BRACKET
     ;

%%
