﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;

namespace SimpleLang.Visitors
{
    public class CommonlyUsedVarVisitor : AutoVisitor
    {
        Dictionary<string, int> frequencyCount = new Dictionary<string, int>();
        public string mostCommonlyUsedVar()
        {
            string ans = "";
            int max = 0;
            foreach (var f in frequencyCount)
            {
                if(f.Value > max)
                {
                    ans = f.Key;
                    max = f.Value;
                }
            }
            return ans;
        }

        public override void VisitIdNode(IdNode id)
        {
            if (frequencyCount.ContainsKey(id.Name))
            {
               frequencyCount[id.Name]++;
            }
            else 
            {
                frequencyCount.Add(id.Name, 0);
            }
        }
    }
}
