﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;

namespace SimpleLang.Visitors
{
    public class CountCyclesOpVisitor : AutoVisitor
    {
        int cycles = 0;
        int op = 0;
        int cycleDepth = 0;

        public int MidCount()
        {
            if(cycles == 0)
            {
                return 0;
            }
            else
            {
                return op / cycles;
            }
        }

        /*public override void VisitBinOpNode(BinOpNode binop)
        {
            if(cycleDepth > 0)
            {
                op++;
            }
            binop.Left.Visit(this);
            binop.Right.Visit(this);
        } */

        public override void VisitAssignNode(AssignNode a)
        {
            if (cycleDepth > 0)
            {
                op++;
            }
            a.Expr.Visit(this); 
        }

        public override void VisitCycleNode(CycleNode c)
        {
            cycleDepth++;
            cycles++;
            c.Stat.Visit(this);
            cycleDepth--;   
        }

        public override void VisitWriteNode(WriteNode w)
        {
            if (cycleDepth > 0)
            {
                op++;
            }
            w.Expr.Visit(this);
        }
    }
}
