using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProgramTree;


namespace SimpleLang.Visitors
{
    public class MaxIfCycleNestVisitor : AutoVisitor
    {
        public int MaxNest = 0;
        int count = 0;

        public override void VisitIfNode(IfNode f)
        {
            count++;
            f.StatIf.Visit(this);
            if (f.StatElse != null)
            {
                f.StatElse.Visit(this);
            }
            if (count > MaxNest)
            {
                MaxNest = count;
            }
            count--;

        }
        public override void VisitCycleNode(CycleNode c)
        {
            count++;
            c.Stat.Visit(this);
            if (count > MaxNest)
            {
                MaxNest = count;
            }
            count--;

        }
    }
}